#define _HUYGENS_INT_
#define _CRT_NON_CONFORMING_SWPRINTFS
#define _CRT_SECURE_NO_WARNINGS
#include <shlobj.h>
#include <shlwapi.h>
#include "stdafx.h"
#include "imageview_int.h"
#include "filedlg.h"
#include <strsafe.h>
#include <new>

/*
Example:
const FILDEDLG_FILTERSPEC c_rgSaveTypes[] =
{
    { L"Bitmap (*.bmp)",   L"*.bmp" }
    { L"PNG (*.png)",   L"*.png" },
    { L"JPEG (*.jpg)",   L"*.jpg" },
	{ 0, 0 }
};*/

bool QueryFileDialogue(HWND hWnd, FILEDLG_TYPE type, csrutils::StringB& szPath, const FILDEDLG_FILTERSPEC *filter, LPCWSTR defFiler) {
    HRESULT hr = S_OK;
    IFileDialog *pfd = NULL;
	switch(type) {
	case FILEDLG_OPEN:
		hr = CoCreateInstance(CLSID_FileOpenDialog,NULL,CLSCTX_INPROC_SERVER,IID_PPV_ARGS(&pfd));
		break;
	case FILEDLG_SAVE:
		hr = CoCreateInstance(CLSID_FileSaveDialog,NULL,CLSCTX_INPROC_SERVER,IID_PPV_ARGS(&pfd));
		break;
	default:
		return false;
	}
	if( ! SUCCEEDED(hr) ) {
		return false;
	}
	switch(type) {
	case FILEDLG_OPEN:
		hr = pfd->SetTitle(L"Open a File");
		break;
	case FILEDLG_SAVE:
		hr = pfd->SetTitle(L"Save a File");
		break;
	default:
		return false;
	}
	if( ! SUCCEEDED(hr) ) {
		pfd->Release();
		return false;
	}
	int countFiler;
	for( countFiler = 0; filter[countFiler].pszName != NULL; countFiler++ ) { }
	hr = pfd->SetFileTypes(countFiler,(const COMDLG_FILTERSPEC*)filter);
	if( ! SUCCEEDED(hr) ) {
		pfd->Release();
		return false;
	}
	hr = pfd->SetFileTypeIndex(1);
	if( ! SUCCEEDED(hr) ) {
		pfd->Release();
		return false;
	}
    hr = pfd->SetDefaultExtension(defFiler);
	if( ! SUCCEEDED(hr) ) {
		pfd->Release();
		return false;
	}
	DWORD dwOptions;
	hr = pfd->GetOptions(&dwOptions);
	if( ! SUCCEEDED(hr) ) {
		pfd->Release();
		return false;
	}
    hr = pfd->SetOptions( dwOptions | FOS_OVERWRITEPROMPT );
	if( ! SUCCEEDED(hr) ) {
		pfd->Release();
		return false;
	}
	hr = pfd->Show(hWnd);
	if( ! SUCCEEDED(hr) ) {
		pfd->Release();
		return false;
	}
	IShellItem *psiResult = NULL;
	hr = pfd->GetResult(&psiResult);
	if( ! SUCCEEDED(hr) ) {
		pfd->Release();
		return false;
	}
	PWSTR pszPath = NULL;
	hr = psiResult->GetDisplayName(SIGDN_FILESYSPATH, &pszPath);
	if( ! SUCCEEDED(hr) ) {
		pfd->Release();
		psiResult->Release();
		return false;
	}
	szPath = pszPath;
	CoTaskMemFree(pszPath);
	pfd->Release();
	psiResult->Release();
	return true;
}
