#define _HUYGENS_INT_
#include "stdafx.h"
#include <map>

using namespace csrutils;

struct HInstance_Ctx {
	std::map<StringB,const HOpticalElementClass*> elementClasses;
};

HInstance::HInstance(HINSTANCE hInst) : hInst(hInst) {
	ctx = new HInstance_Ctx;
}

HInstance::~HInstance() {
	delete ctx;
}

void HInstance::regElementClass(const HOpticalElementClass* cls) {
	ctx->elementClasses[cls->nmType] = cls;
}

int HInstance::getElementClasses(const HOpticalElementClass** clses) {
	if( clses!=0 ) {
		int i = 0;
		for( auto iter = ctx->elementClasses.begin(); iter != ctx->elementClasses.end(); iter++ ) {
			clses[i++] = (*iter).second;
		}
	}
	return (int) ctx->elementClasses.size();
}

const HOpticalElementClass* HInstance::getElementClass(const wchar_t* name) {
	if( ctx->elementClasses.find(name) == ctx->elementClasses.end() )
		return 0;
	return ctx->elementClasses[name];
}