#define _CRT_SECURE_NO_WARNINGS

#include "stdafx.h"

#include <stdio.h>

#include "image.h"

IMAGE *LoadImageFile(LPWSTR filename) {
	BITMAPFILEHEADER bmfh;
	DWORD sz;
	HANDLE fd = CreateFile(filename,GENERIC_READ,0,0,OPEN_EXISTING,0,0);
	ReadFile(fd,&bmfh,sizeof(BITMAPFILEHEADER),&sz,0);
	IMAGE *img = new IMAGE;
	ReadFile(fd,&img->bmih,sizeof(BITMAPINFOHEADER),&sz,0);
	img->width	= img->bmih.biWidth;
	img->height	= img->bmih.biHeight;
	size_t size = STRIDELENGTH(img->width) * img->height;
	img->data	= (unsigned char*) VirtualAlloc(0,size,MEM_COMMIT,PAGE_READWRITE);
	ReadFile(fd,img->data,(DWORD)size,&sz,0);
	CloseHandle(fd);
	return img;
}

bool SaveImageFile(IMAGE *img, LPWSTR filename) {
	BITMAPFILEHEADER bmfh = {0};
	DWORD sz;
	size_t size = STRIDELENGTH(img->width) * img->height;
	HANDLE fd = CreateFile(filename,GENERIC_WRITE,0,0,CREATE_ALWAYS,0,0);
	bmfh.bfType		= 0x4d42;
	bmfh.bfSize		= sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER) + (DWORD)size;
	bmfh.bfOffBits	= sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);
	WriteFile(fd,&bmfh,sizeof(BITMAPFILEHEADER),&sz,0);
	WriteFile(fd,&img->bmih,sizeof(BITMAPINFOHEADER),&sz,0);
	WriteFile(fd,img->data,(DWORD)size,&sz,0);
	CloseHandle(fd);
	return true;
}

IMAGE *CreateImageSame(IMAGE *src) {
	IMAGE *img = new IMAGE;
	img->bmih	= src->bmih;
	img->width	= src->width;
	img->height	= src->height;
	size_t size = STRIDELENGTH(img->width) * img->height;
	img->data	= (unsigned char*) VirtualAlloc(0,size,MEM_COMMIT,PAGE_READWRITE);
	return img;
}

IMAGE *CreateImage(int width, int height) {
	IMAGE *img = new IMAGE;
	img->width = width;
	img->height = height;
	size_t size = STRIDELENGTH(img->width) * img->height;
	img->bmih.biSize			= sizeof(BITMAPINFOHEADER);
    img->bmih.biWidth			= width;
    img->bmih.biHeight			= height;
    img->bmih.biPlanes			= 1;
    img->bmih.biBitCount		= 24;
    img->bmih.biCompression		= 0;
    img->bmih.biSizeImage		= size;
    img->bmih.biXPelsPerMeter	= 0;
    img->bmih.biYPelsPerMeter	= 0;
    img->bmih.biClrUsed			= 0;
    img->bmih.biClrImportant	= 0;
	img->data	= (unsigned char*) VirtualAlloc(0,size,MEM_COMMIT,PAGE_READWRITE);
	return img;
}

HBITMAP CreateBitmapOfImage(IMAGE *img, HDC hdc) {
	unsigned char* data;
	size_t size = STRIDELENGTH(img->width) * img->height;
	BITMAPINFO bmi = { img->bmih, 0 };
	HBITMAP hbm = CreateDIBSection(hdc,&bmi,DIB_RGB_COLORS,(void**)&data,0,0);
	memcpy(data,img->data,size);
	VirtualFree(img->data,size,MEM_FREE);
	img->data = data;
	return hbm;
}

bool loaddatafile(const char *name, void **data, size_t *size) {
	FILE *fp = fopen(name,"rb");
	if( fp==0 )
		return false;
	fseek(fp, 0L, SEEK_END);
	*size = ftell(fp);
	fseek(fp, 0L, SEEK_SET);
	*data = new char[*size];
	fread(*data,*size,1,fp);
	fclose(fp);
	return true;
}
